Index: src/Fl_Browser_.cxx
===================================================================
--- src/Fl_Browser_.cxx	(revision 6732)
+++ src/Fl_Browser_.cxx	(working copy)
@@ -1,4 +1,5 @@
 //
+//
 // "$Id$"
 //
 // Base Browser widget class for the Fast Light Tool Kit (FLTK).
@@ -667,6 +668,9 @@
     set_changed();
     do_callback();
   }
+#ifdef FL_HAVE_MSAA
+  msaa_on_focus();
+#endif // FL_HAVE_MSAA
   return 1;
 }
 
@@ -750,6 +754,9 @@
         case ' ':
           selection_ = l;
           select(l, !item_selected(l), when() & ~FL_WHEN_ENTER_KEY);
+#ifdef FL_HAVE_MSAA
+          msaa_on_focus();
+#endif // FL_HAVE_MSAA
           return 1;
         case FL_Down:
           while ((l = item_next(l))) {
@@ -769,6 +776,9 @@
           if (selection_) redraw_line(selection_);
           selection_ = l; redraw_line(l);
           display(l);
+#ifdef FL_HAVE_MSAA
+          msaa_on_focus();
+#endif // FL_HAVE_MSAA
           return 1;
         }
       }
@@ -906,6 +916,9 @@
       select_only(l, when() & FL_WHEN_CHANGED);
     }
     py = my;
+#ifdef FL_HAVE_MSAA
+    msaa_on_focus();
+#endif // FL_HAVE_MSAA
     return 1;
   case FL_RELEASE:
     if (type() == FL_SELECT_BROWSER) {
@@ -966,6 +979,10 @@
   max_width_item = 0;
   redraw1 = redraw2 = 0;
   end();
+#ifdef FL_HAVE_MSAA
+  // Initialize MSAA stuff
+  msaa_browser_proxy_ = 0;
+#endif // FL_HAVE_MSAA
 }
 
 /**
@@ -1083,6 +1100,792 @@
 */
 int Fl_Browser_::item_selected(void* item) const { return item==selection_ ? 1 : 0; }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+#include <FL/x.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+#define CID_LIST	1
+#define CID_VERTICAL	2
+#define CID_HORIZONTAL	3
+#define CID_GRIP	4
+
+
+// Specialized MSAA proxy for Fl_Browser_ object
+class Fl_Msaa_Browser_Proxy : public Fl_Msaa_Proxy
+{
+public:
+  Fl_Msaa_Browser_Proxy(Fl_Widget* o) : Fl_Msaa_Proxy(o)  {}
+
+  // IAccessible implementation
+  HRESULT STDMETHODCALLTYPE get_accParent(IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accChildCount(long*);
+  HRESULT STDMETHODCALLTYPE get_accChild(VARIANT, IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accName(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accValue(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accDescription(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accRole(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accState(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accHelp(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accHelpTopic(BSTR*, VARIANT, long*);
+  HRESULT STDMETHODCALLTYPE get_accKeyboardShortcut(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accFocus(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accSelection(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accDefaultAction(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE accSelect(long, VARIANT);
+  HRESULT STDMETHODCALLTYPE accLocation(long*, long*, long*, long*, VARIANT);
+  HRESULT STDMETHODCALLTYPE accNavigate(long, VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accHitTest(long, long, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accDoDefaultAction(VARIANT);
+  HRESULT STDMETHODCALLTYPE put_accValue(VARIANT, BSTR);
+};
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accParent(
+    /* [retval][out] */ IDispatch** ppdispParent)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!ppdispParent)  return E_INVALIDARG;
+  *ppdispParent = NULL;
+
+  // Fl_Msaa_Browser_Proxy_ has a Fl_Msaa_Proxy parent
+  Fl_Msaa_Proxy* parent = browser->msaa_child(0);
+  if (!parent)  return S_FALSE;
+  parent->QueryInterface(IID_IDispatch, (void**)ppdispParent);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accChildCount(
+    /* [retval][out] */ long* pcountChildren)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pcountChildren)  return E_INVALIDARG;
+  *pcountChildren = browser->msaa_browser_size();
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accChild(
+    /* [in] */ VARIANT varChild,
+    /* [retval][out] */ IDispatch** ppdispChild)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (varChild.vt != VT_I4)  return E_INVALIDARG;
+  if (!ppdispChild)  return E_INVALIDARG;
+  *ppdispChild = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  return S_FALSE;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accName(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszName)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszName)  return E_INVALIDARG;
+  *pszName = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)  return Fl_Msaa_Proxy::get_accName(varChild, pszName);
+
+  // Report text of required item as name
+  if (!browser->msaa_browser_text(id, pszName))  return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszValue)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszValue)  return E_INVALIDARG;
+  *pszValue = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)  return Fl_Msaa_Proxy::get_accValue(varChild, pszValue);
+
+  // No value for list items
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accDescription(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDescription)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDescription)  return E_INVALIDARG;
+  *pszDescription = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)
+    return Fl_Msaa_Proxy::get_accDescription(varChild, pszDescription);
+
+  // Report description of required list item
+  if (!browser->msaa_browser_description(id, pszDescription))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accRole(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarRole)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarRole)  return E_INVALIDARG;
+  pvarRole->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+
+  pvarRole->vt   = VT_I4;
+  pvarRole->lVal = (id == 0 ? ROLE_SYSTEM_LIST : ROLE_SYSTEM_LISTITEM);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accState(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ VARIANT* pvarState)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarState)  return E_INVALIDARG;
+  pvarState->vt = VT_EMPTY;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)  return Fl_Msaa_Proxy::get_accState(varChild, pvarState);
+
+  // Indicate whether a list item is visible
+  pvarState->vt   = VT_I4;
+  pvarState->lVal = STATE_SYSTEM_SELECTABLE |
+    (browser->type() == FL_MULTI_BROWSER ? STATE_SYSTEM_MULTISELECTABLE : 0) |
+    (browser->msaa_browser_selected(id) ? STATE_SYSTEM_SELECTED : 0) |
+    (browser->msaa_browser_displayed(id) ? 0 :
+    	(STATE_SYSTEM_INVISIBLE | STATE_SYSTEM_OFFSCREEN));
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accHelp(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszHelp)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelp)  return E_INVALIDARG;
+  *pszHelp = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)  return Fl_Msaa_Proxy::get_accHelp(varChild, pszHelp);
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accHelpTopic(
+    /* [out] */ BSTR* pszHelpFile,
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ long* pidTopic)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszHelpFile)  return E_INVALIDARG;
+  if (!pidTopic)  return E_INVALIDARG;
+  *pszHelpFile = NULL;
+  *pidTopic = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)
+    return Fl_Msaa_Proxy::get_accHelpTopic(pszHelpFile, varChild, pidTopic);
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accKeyboardShortcut(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszKeyboardShortcut)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszKeyboardShortcut)  return E_INVALIDARG;
+  *pszKeyboardShortcut = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)
+    return Fl_Msaa_Proxy::get_accKeyboardShortcut(
+      varChild, pszKeyboardShortcut);
+
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accFocus(
+    /* [retval][out] */ VARIANT *pvarChild)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Check whether the browser has keyboard focus
+  Fl_Widget* f = Fl::focus();
+  if (f != browser)  return S_OK;
+
+  // Now return index of item with focus
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = browser->msaa_browser_focus();
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accSelection(
+    /* [retval][out] */ VARIANT* pvarChildren)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChildren)  return E_INVALIDARG;
+
+  // Build list of selected items
+  long*  sel = NULL;
+  size_t buf_size = 0;
+  size_t count = 0;
+  if (browser->type() == FL_MULTI_BROWSER)
+  {
+    void* l = browser->item_first();
+    for (int n = 1;  l;  l = browser->item_next(l), ++n)
+    {
+      if (browser->item_selected(l))
+      {
+        if (count >= buf_size)
+        {
+	  if (buf_size == 0)  buf_size = 4;
+	  else  buf_size *= 2;
+	  sel = (long*)realloc(sel, sizeof(long) * buf_size);
+	}
+        sel[count++] = n;
+      }
+      if (l == browser->item_last())  break;
+    }
+  }
+  else if (browser->selection())
+  {
+    sel = (long*)malloc(sizeof(long));
+    sel[0] = browser->msaa_browser_find_item(browser->selection());
+    count = 1;
+  }
+
+  // Put selection in VARIANT
+  Fl_Widget::msaa_convert_selection(sel, count, pvarChildren);
+  if (sel)  free(sel);
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::get_accDefaultAction(
+    /* [optional][in] */ VARIANT varChild,
+    /* [retval][out] */ BSTR* pszDefaultAction)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pszDefaultAction)  return E_INVALIDARG;
+  *pszDefaultAction = NULL;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)
+    return Fl_Msaa_Proxy::get_accDefaultAction(varChild, pszDefaultAction);
+
+  // No default action for list items
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::accSelect(
+    /* [in] */ long flagsSelect,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+  if (id == 0)  return Fl_Msaa_Proxy::accSelect(flagsSelect, varChild);
+
+  if (flagsSelect == SELFLAG_NONE)  return S_OK;
+  if (!browser->msaa_browser_do_select(id, flagsSelect))
+    return DISP_E_MEMBERNOTFOUND;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::accLocation(
+    /* [out] */ long* pxLeft,
+    /* [out] */ long* pyTop,
+    /* [out] */ long* pcxWidth,
+    /* [out] */ long* pcyHeight,
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pxLeft || !pyTop || !pcxWidth || !pcyHeight)  return E_INVALIDARG;
+  *pxLeft = *pyTop = *pcxWidth = *pcyHeight = 0;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+
+  if (id == 0)
+  {
+    browser->msaa_browser_bbox(pxLeft, pyTop, pcxWidth, pcyHeight);
+    return S_OK;
+  }
+  if (browser->msaa_browser_item_bbox(id, pxLeft, pyTop, pcxWidth, pcyHeight))
+    return S_OK;
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::accNavigate(
+    /* [in] */ long navDir,
+    /* [optional][in] */ VARIANT varStart,
+    /* [retval][out] */ VARIANT* pvarEndUpAt)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarEndUpAt)  return E_INVALIDARG;
+  pvarEndUpAt->vt = VT_EMPTY;
+  long id = (varStart.vt == VT_I4 ? varStart.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+
+  // Handle navigation relative to this widget
+  if ((id == 0) &&
+      (navDir != NAVDIR_FIRSTCHILD) && (navDir != NAVDIR_LASTCHILD))
+  {
+    // Forward request to browser widget
+    varStart.vt   = VT_I4;
+    varStart.lVal = CID_LIST;
+    return Fl_Msaa_Proxy::accNavigate(navDir, varStart, pvarEndUpAt);
+  }
+
+  // Handle navigation within browser content
+  long max_id = browser->msaa_browser_size();
+  if (max_id < 1)  return DISP_E_MEMBERNOTFOUND;
+  long dst;
+  switch (navDir)
+  {
+    case NAVDIR_FIRSTCHILD:  dst = 1;  break;
+    case NAVDIR_LASTCHILD:   dst = max_id;  break;
+    case NAVDIR_UP:	     // Fall through
+    case NAVDIR_PREVIOUS:    dst = (id == 1 ? -1 : (id - 1));  break;
+    case NAVDIR_DOWN:	     // Fall through
+    case NAVDIR_NEXT:	     dst = (id == max_id ? -1 : (id + 1));  break;
+
+    // Left/right navigation not supported
+    case NAVDIR_LEFT:	     // Fall through
+    case NAVDIR_RIGHT:	     // Fall through
+    default:		     dst = -1;  break;
+  }
+  if (dst < 0)  return DISP_E_MEMBERNOTFOUND;
+  pvarEndUpAt->vt   = VT_I4;
+  pvarEndUpAt->lVal = dst;
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::accHitTest(
+    /* [in] */ long xLeft,
+    /* [in] */ long yTop,
+    /* [retval][out] */ VARIANT* pvarChild)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  if (!pvarChild)  return E_INVALIDARG;
+  pvarChild->vt = VT_EMPTY;
+
+  // Convert to Fl_Window co-ordinates
+  POINT pt = {xLeft, yTop};
+  ScreenToClient(fl_xid(browser->window()), &pt);
+
+  // Check if it's outside the browser
+  if ((pt.x < browser->x()) || (pt.x >= browser->x() + browser->w()) ||
+      (pt.y < browser->y()) || (pt.y >= browser->y() + browser->h()))
+    return S_FALSE;
+
+  // Return child ID
+  pvarChild->vt   = VT_I4;
+  pvarChild->lVal = browser->msaa_browser_find_item(browser->find_item(pt.y));
+  return S_OK;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::accDoDefaultAction(
+    /* [optional][in] */ VARIANT varChild)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+HRESULT STDMETHODCALLTYPE
+Fl_Msaa_Browser_Proxy::put_accValue(
+    /* [optional][in] */ VARIANT varChild,
+    /* [in] */ BSTR szValue)
+{
+  Fl_Browser_* browser = (Fl_Browser_*)mpObj;
+  if (!browser)  return CO_E_OBJNOTCONNECTED;
+  long id = (varChild.vt == VT_I4 ? varChild.lVal : 0);
+  if (id < 0 || id > browser->msaa_browser_size())  return E_INVALIDARG;
+
+  return DISP_E_MEMBERNOTFOUND;
+}
+
+
+/*------------------------- Fl_Browser_ MSAA support -----------------------*/
+
+void
+Fl_Browser_::msaa_cleanup()
+{
+  // Destroy custom proxy
+  if (msaa_browser_proxy_)
+  {
+    msaa_browser_proxy_->Detach();
+    msaa_browser_proxy_->Release();
+  }
+
+  // Destroy standard proxy
+  Fl_Group::msaa_cleanup();
+}
+
+
+long
+Fl_Browser_::msaa_child_id(Fl_Widget* o) const
+{
+  if (o == this)	 return 0;
+  if (o == &scrollbar)	 return CID_VERTICAL;
+  if (o == &hscrollbar)	 return CID_HORIZONTAL;
+  return -1;
+}
+
+
+Fl_Widget*
+Fl_Browser_::msaa_child_widget(long id) const
+{
+  switch (id)
+  {
+    case 0:		  return (Fl_Widget*)this;
+    case CID_VERTICAL:	  return (Fl_Widget*)&scrollbar;
+    case CID_HORIZONTAL:  return (Fl_Widget*)&hscrollbar;
+    default:		  return NULL;
+  }
+}
+
+
+Fl_Msaa_Proxy*
+Fl_Browser_::msaa_child(long id)
+{
+  if (id != CID_LIST)  return Fl_Group::msaa_child(id);
+
+  // Create specialized list proxy
+  if (!msaa_browser_proxy_)
+  {
+    msaa_browser_proxy_ = new Fl_Msaa_Browser_Proxy(this);
+    if (msaa_browser_proxy_)  msaa_browser_proxy_->AddRef();
+  }
+  return msaa_browser_proxy_;
+}
+
+
+long
+Fl_Browser_::msaa_role(long id)
+{
+  switch (id)
+  {
+    case CID_LIST:	  return ROLE_SYSTEM_LIST;
+    case CID_GRIP:	  return ROLE_SYSTEM_GRIP;
+    default:		  return Fl_Group::msaa_role(id);
+  }
+}
+
+
+long
+Fl_Browser_::msaa_state(long id)
+{
+  switch (id)
+  {
+    case 0:
+      return Fl_Group::msaa_state(id) & ~STATE_SYSTEM_FOCUSED;
+    case CID_LIST:
+      return Fl_Group::msaa_state(id) |
+        (Fl::focus() == this ? STATE_SYSTEM_FOCUSED : 0);
+    case CID_GRIP:
+      return (scrollbar.visible() && hscrollbar.visible()) ?
+        0 : STATE_SYSTEM_INVISIBLE;
+    default:
+      return Fl_Group::msaa_state(id);
+  }
+}
+
+
+long
+Fl_Browser_::msaa_focus()
+{
+  int id = Fl_Group::msaa_focus();
+  if (id == 0)  return CID_LIST;
+  return id;
+}
+
+
+bool 
+Fl_Browser_::msaa_location(long id, long* X, long* Y, long* W, long* H)
+{
+  if (!msaa_visible())  return false;
+  switch (id)
+  {
+    case CID_LIST:
+      msaa_browser_bbox(X, Y, W, H);
+      return true;
+
+    case CID_GRIP:
+      if (scrollbar.visible() && hscrollbar.visible())
+      {
+	long dummy;
+        Fl_Group::msaa_location(CID_VERTICAL, X, &dummy, W, &dummy);
+	Fl_Group::msaa_location(CID_HORIZONTAL, &dummy, Y, &dummy, H);
+        return true;
+      }
+      return false;
+
+    default:
+      return Fl_Group::msaa_location(id, X, Y, W, H);
+  }
+}
+
+
+void
+Fl_Browser_::msaa_browser_bbox(long* X, long* Y, long* W, long* H)
+{
+  Fl_Window* win = window();
+  int oX, oY, oW, oH;
+  bbox(oX, oY, oW, oH);
+  *X = oX + win->x();
+  *Y = oY + win->y();
+  *W = oW;
+  *H = oH;
+}
+
+
+void
+Fl_Browser_::msaa_on_focus()
+{
+  if (Fl::focus() != this)  return;
+  if (!selection_)  Fl_Widget::msaa_on_focus();
+  Fl_Msaa_Proxy* proxy = msaa_child(CID_LIST);
+  if (!proxy)  return;
+  NotifyWinEvent(EVENT_OBJECT_FOCUS, fl_xid(msaa_window()),
+    (LONG)proxy, msaa_browser_focus());
+}
+
+
+bool
+Fl_Browser_::msaa_browser_item_bbox(long id,
+    long* X, long* Y, long* W, long* H)
+{
+  if (id < 1)  return false;
+  void* l;
+  for (l = item_first();  --id;  l = item_next(l));
+  if (!displayed(l))  return false;
+  long top_y, full_h;
+  msaa_browser_bbox(X, &top_y, W, &full_h);
+  *Y = top_y - offset_;
+  *H = item_height(l);
+  while (l != top_)
+  {
+    l = item_prev(l);
+    *Y += item_height(l);
+  }
+  if ((*Y + *H) > (top_y + full_h))  *H -= (top_y + full_h - *Y);
+  return true;
+}
+
+
+long
+Fl_Browser_::msaa_browser_size()
+{
+  long count = 0;
+  for (void* l = item_first();  l;  l = item_next(l))  count++;
+  return count;
+}
+
+
+bool
+Fl_Browser_::msaa_browser_displayed(long id)
+{
+  if (id < 1)  return false;
+  void* l;
+  for (l = item_first();  --id;  l = item_next(l));
+  return displayed(l);
+}
+
+
+bool
+Fl_Browser_::msaa_browser_selected(long id)
+{
+  if (id < 1)  return false;
+  void* l;
+  for (l = item_first();  --id;  l = item_next(l));
+  return item_selected(l);
+}
+
+
+long 
+Fl_Browser_::msaa_browser_find_item(void* l)
+{
+  int line = 0;
+  for (;  l;  l = item_prev(l), ++line);
+  return line;
+}
+
+
+long
+Fl_Browser_::msaa_browser_focus()
+{
+  return msaa_browser_find_item(selection_);
+}
+
+
+void
+Fl_Browser_::msaa_browser_set_focus(long id)
+{
+  if (id < 1)  return;
+  void* l;
+  for (l = item_first();  --id;  l = item_next(l));
+  selection_ = l;
+  display(l);
+}
+
+
+bool
+Fl_Browser_::msaa_browser_do_select(long id, long flags)
+{
+  if (id < 1)  return false;
+
+  // Handle focusing of list item
+  if (flags == SELFLAG_TAKEFOCUS)
+  {
+    msaa_browser_set_focus(id);
+    return true;
+  }
+
+  // Handle single selection of list item
+  if (flags & SELFLAG_TAKESELECTION)
+  {
+    msaa_browser_set_focus(id);
+    select_only(selection_, when());
+    return true;
+  }
+
+  // The remaining operations are permitted only in multi-selection browser
+  if (type() != FL_MULTI_BROWSER)  return false;
+  bool is_extend = flags & SELFLAG_EXTENDSELECTION;
+  bool is_add = flags & SELFLAG_ADDSELECTION;
+  bool is_remove = flags & SELFLAG_REMOVESELECTION;
+
+  // Handle addition of item to selection
+  if (is_add && !is_extend)
+  {
+    msaa_browser_set_focus(id);
+    select(selection_, 1, when());
+    return true;
+  }
+
+  // Handle removal of item from selection
+  if (is_remove && !is_extend)
+  {
+    msaa_browser_set_focus(id);
+    select(selection_, 0, when());
+    return true;
+  }
+
+  // Handle extension of selection
+  if (is_extend)
+  {
+    // Determine state of extended items
+    void* old_l = selection_;
+    long  anchor;
+    bool  new_state;
+    if (!old_l)
+    {
+      old_l     = item_first();
+      anchor    = 1;
+      new_state = 1;
+    }
+    else
+    {
+      anchor = msaa_browser_focus();
+      if (is_add)          new_state = 1;
+      else if (is_remove)  new_state = 0;
+      else                 new_state = item_selected(old_l);
+    }
+
+    // Update the selection now
+    msaa_browser_set_focus(id);
+    void* new_l = selection_;
+    for (;;)
+    {
+      select(old_l, new_state, 0);
+      if (old_l == new_l)  break;
+      old_l = (anchor < id ? item_next(old_l) : item_prev(old_l));
+    }
+
+    // Invoke callback function
+    if (when())
+    {
+      set_changed();
+      do_callback();
+    }
+    return true;
+  }
+
+  return false;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Value_Output.cxx
===================================================================
--- src/Fl_Value_Output.cxx	(revision 6732)
+++ src/Fl_Value_Output.cxx	(working copy)
@@ -103,6 +103,22 @@
   soft_ = 0;
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+long
+Fl_Value_Output::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  return ROLE_SYSTEM_STATICTEXT;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_Valuator.cxx
===================================================================
--- src/Fl_Valuator.cxx	(revision 6732)
+++ src/Fl_Valuator.cxx	(working copy)
@@ -83,6 +83,9 @@
   if (v == value_) return 0;
   value_ = v;
   value_damage();
+#ifdef FL_HAVE_MSAA
+  msaa_valuator_on_change();
+#endif // FL_HAVE_MSAA
   return 1;
 }
 /** Clamps the value, but accepts v if the previous value is not already out of range */
@@ -102,6 +105,9 @@
     value_damage();
     set_changed();
     if (when() & FL_WHEN_CHANGED) do_callback();
+#ifdef FL_HAVE_MSAA
+    msaa_valuator_on_change();
+#endif // FL_HAVE_MSAA
   }
 }
 /** Called after an FL_WHEN_RELEASE event is received and before the callback. */
@@ -115,6 +121,9 @@
     if (value_ != previous_value_ || when() & FL_WHEN_NOT_CHANGED) {
       do_callback();
     }
+#ifdef FL_HAVE_MSAA
+    if (value_ != previous_value_)  msaa_valuator_on_change();
+#endif // FL_HAVE_MSAA
   }
 }
 
@@ -191,6 +200,41 @@
   return snprintf(buffer, 128, "%.*f", c, v);
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+void
+Fl_Valuator::msaa_valuator_on_change()
+{
+  msaa_notify(EVENT_OBJECT_VALUECHANGE);
+}
+
+
+bool
+Fl_Valuator::msaa_value(long id, BSTR* bstr)
+{
+  if (id != 0)  return Fl_Widget::msaa_value(id, bstr);
+  char str[128];
+  format(str);
+  fl_str_to_bstr(str, -1, bstr);
+  return true;
+}
+
+
+bool 
+Fl_Valuator::msaa_put_value(long id, const char* str)
+{
+  if (id != 0)  return Fl_Widget::msaa_put_value(id, str);
+  value(atof(str));
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // End of "$Id$".
 //
Index: src/Fl_win32.cxx
===================================================================
--- src/Fl_win32.cxx	(revision 6732)
+++ src/Fl_win32.cxx	(working copy)
@@ -73,6 +73,63 @@
 
 #include "aimm.h"
 
+
+#ifdef FL_HAVE_MSAA
+#  include <FL/Fl_Msaa_Proxy.H>
+
+/*
+ * Dynamic linking of oleacc.dll
+ * This library is only needed for two functions relating to MSAA
+ */
+flTypeLresultFromObject flLresultFromObject = 0;
+flTypeAccessibleObjectFromWindow flAccessibleObjectFromWindow = 0;
+
+static HMODULE s_oleacc_module = 0;
+static HMODULE get_oleacc_module() {
+  if (!s_oleacc_module) {
+    s_oleacc_module = LoadLibrary("OLEACC.DLL");
+    if (!s_oleacc_module)
+      Fl::fatal("FLTK Lib Error: OLEACC.DLL file not found!\n\n"
+        "Please check your active accessibility library availability.");
+    flLresultFromObject = (flTypeLresultFromObject)
+        GetProcAddress(s_oleacc_module, "LresultFromObject");
+    flAccessibleObjectFromWindow = (flTypeAccessibleObjectFromWindow)
+        GetProcAddress(s_oleacc_module, "AccessibleObjectFromWindow");
+  }
+  return s_oleacc_module;
+}
+
+
+/*
+ * Dynamic linking of oleaut32.dll
+ * This library is only needed for four functions relating to MSAA
+ */
+flTypeVariantCopy flVariantCopy = 0;
+flTypeVariantClear flVariantClear = 0;
+flTypeSysStringLen flSysStringLen = 0;
+flTypeSysAllocStringLen flSysAllocStringLen = 0;
+
+static HMODULE s_oleaut32_module = 0;
+static HMODULE get_oleaut32_module() {
+  if (!s_oleaut32_module) {
+    s_oleaut32_module = LoadLibrary("OLEAUT32.DLL");
+    if (!s_oleaut32_module)
+      Fl::fatal("FLTK Lib Error: OLEAUT32.DLL file not found!\n\n"
+        "Please check your OLE32 library availability.");
+    flVariantCopy = (flTypeVariantCopy)
+        GetProcAddress(s_oleaut32_module, "VariantCopy");
+    flVariantClear = (flTypeVariantClear)
+        GetProcAddress(s_oleaut32_module, "VariantClear");
+    flSysStringLen = (flTypeSysStringLen)
+        GetProcAddress(s_oleaut32_module, "SysStringLen");
+    flSysAllocStringLen = (flTypeSysAllocStringLen)
+        GetProcAddress(s_oleaut32_module, "SysAllocStringLen");
+  }
+  return s_oleaut32_module;
+}
+#endif // FL_HAVE_MSAA
+
+
 //
 // USE_ASYNC_SELECT - define it if you have WSAAsyncSelect()...
 // USE_ASYNC_SELECT is OBSOLETED in 1.3 for the following reasons:
@@ -1173,6 +1230,28 @@
     if (fl_msg.message == WM_RENDERALLFORMATS) CloseClipboard();
     return 1;}
 
+#ifdef FL_HAVE_MSAA
+  case WM_GETOBJECT: {
+    get_oleacc_module();
+    get_oleaut32_module();
+
+    Fl_Msaa_Proxy* proxy = NULL;
+    if ((DWORD)fl_msg.lParam == OBJID_CLIENT) {
+      // Return IAccessible proxy for client area
+      proxy = window->msaa_proxy();
+    } else if (fl_msg.lParam > 0) {
+      // Return IAccessible proxy for custom object IDs
+      proxy = (Fl_Msaa_Proxy*)fl_msg.lParam;
+    }
+
+    // Make sure a proxy object exists
+    if (!proxy)  break;
+
+    // Pass IAccessible proxy to MSAA
+    return flLresultFromObject(IID_IAccessible,
+	fl_msg.wParam, (IUnknown*)proxy);}
+#endif // FL_HAVE_MSAA
+
   default:
     if (Fl::handle(0,0)) return 0;
     break;
Index: src/Fl_Choice.cxx
===================================================================
--- src/Fl_Choice.cxx	(revision 6732)
+++ src/Fl_Choice.cxx	(working copy)
@@ -203,6 +203,46 @@
   }
 }
 
+
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+bool
+Fl_Choice::msaa_value(long id, BSTR* bstr)
+{
+  if (id != 0)  return Fl_Widget::msaa_value(id, bstr);
+  const Fl_Menu_Item* m = mvalue();
+  if (!m)  return false;
+
+  // For Fl_Choice, name of the selected item becomes its value
+  size_t len;
+  char* name = fl_label_to_text(m->label(), &len);
+  fl_str_to_bstr(name, len, bstr);
+  fl_free_str(name);
+  return true;
+}
+
+
+long
+Fl_Choice::msaa_role(long id)
+{
+  if (id != 0)  return Fl_Widget::msaa_role(id);
+  return ROLE_SYSTEM_COMBOBOX;
+}
+
+
+bool
+Fl_Choice::msaa_put_value(long id, const char* str)
+{
+  if (id != 0)  return Fl_Widget::msaa_put_value(id, str);
+  value(atoi(str));
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
